SystemOrganization addCategory: #BackgammonController!

SimpleSwitchMorph subclass: #InputButton
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonController'!

!InputButton commentStamp: 'jChizmar 7/9/2015 07:56' prior: 0!
A button that responds to input!

!InputButton class methodsFor: 'initialize' stamp: 'DavidOvergaard 7/22/2015 22:27'!
text: labelText boardHeight: boardHeight

	| buttonWidth buttonHeight |
	buttonWidth := 70.
	buttonHeight := 50.
	
	super initialize.
^ ((self new) 	labelString: labelText; 
					minWidth: buttonWidth; 
					extent: buttonWidth@buttonHeight;
					left: 10;
					top: (boardHeight / 2) - (buttonHeight / 2)
	).! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/9/2015 20:50'!
mouseAction: t1
	^ mouseAction := t1! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/22/2015 22:24'!
mouseUp: t1
	mouseAction value.
	^ self! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/22/2015 21:47'!
rollDie: myBoardModel
	| rollCommand |
	rollCommand := (RollCommand new) dice1: (myBoardModel dice1) dice2: (myBoardModel dice2).
	rollCommand execute.
	
	Transcript show: (rollCommand dice1 currentRoll).
	Transcript show: (rollCommand dice2 currentRoll);cr.! !

!InputButton methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:54'!
toggleChecker: aChecker onBoard: myBoardModel
	| myMoveCommand prevLocation |
	
	prevLocation := ((aChecker checkerLocation) pointNumber).
	
	prevLocation = 2
	ifTrue: [ 
		myMoveCommand := MoveCheckerCommand new checker: aChecker location: (myBoardModel points at:12).	
		 ]
	ifFalse: [ 
		myMoveCommand := MoveCheckerCommand new checker: aChecker location: (myBoardModel points at:2 ).	
		 ].
	
	myMoveCommand execute.! !

Object subclass: #BackgammonStart
	instanceVariableNames: 'myBoardModel myBoardView observables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonController'!

!BackgammonStart commentStamp: 'DavidOvergaard 7/16/2015 21:27' prior: 0!
Initialize and run backgammon game!

!BackgammonStart class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 21:27'!
start
	^BackgammonStart new start.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:01'!
model
	^myBoardModel.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:23'!
observable: anObject
	observables add: anObject.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:16'!
observables
	^observables! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/22/2015 22:04'!
start
	| diceButton |
	myBoardModel := MainBoard initialize.
	myBoardView := BackgammonBoard createNewBoard: self.
	observables := OrderedCollection new.

	(myBoardModel player1Checkers) do: [ :aChecker |
		myBoardView addCheckerAtPoint: ((aChecker checkerLocation) pointNumber) color: (aChecker color).
		aChecker addObserver: (myBoardView lastAddedChecker).
		 ].
	
	(myBoardModel player2Checkers) do: [ :aChecker |
		myBoardView addCheckerAtPoint: ((aChecker checkerLocation) pointNumber) color: (aChecker color).
		aChecker addObserver: (myBoardView lastAddedChecker).
		 ].
	
	"Test move with observer"
 	diceButton := InputButton text: 'Roll dice' boardHeight: (myBoardView getBoardSize) y.
	diceButton mouseAction: [diceButton rollDie: myBoardModel].
	myBoardView addMorph: diceButton.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/21/2015 23:43'!
updatedChecker: aChecker toPointNum: pointNum
	| modelChecker moveCheckerCommand |
"	Transcript show: (aChecker location)."
	modelChecker := aChecker observable.
	moveCheckerCommand := (MoveCheckerCommand new) checker: modelChecker location: (myBoardModel points at: pointNum).
	
	moveCheckerCommand execute.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:02'!
view
	^myBoardView := BackgammonBoard createNewBoard.! !
